library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "DDS_PCDAQ/Control Logic"

entity control_logic_entity_fad1345112 is
  port (
    ce_1: in std_logic; 
    clk_1: in std_logic; 
    gpio_sw_c: in std_logic; 
    gpio_sw_e: in std_logic; 
    nrdy_n: in std_logic; 
    constant1_x0: out std_logic_vector(7 downto 0); 
    constant4_x0: out std_logic; 
    constant5_x0: out std_logic; 
    constant6_x0: out std_logic; 
    inverter1_x0: out std_logic; 
    inverter2_x0: out std_logic; 
    inverter_x0: out std_logic
  );
end control_logic_entity_fad1345112;

architecture structural of control_logic_entity_fad1345112 is
  signal ce_1_sg_x0: std_logic;
  signal clk_1_sg_x0: std_logic;
  signal constant1_op_net_x0: std_logic_vector(7 downto 0);
  signal constant4_op_net_x0: std_logic;
  signal constant5_op_net_x0: std_logic;
  signal constant6_op_net_x0: std_logic;
  signal gpio_sw_c_net_x0: std_logic;
  signal gpio_sw_e_net_x0: std_logic;
  signal inverter1_op_net_x0: std_logic;
  signal inverter2_op_net_x0: std_logic;
  signal inverter_op_net_x0: std_logic;
  signal nrdy_n_net_x0: std_logic;

begin
  ce_1_sg_x0 <= ce_1;
  clk_1_sg_x0 <= clk_1;
  gpio_sw_c_net_x0 <= gpio_sw_c;
  gpio_sw_e_net_x0 <= gpio_sw_e;
  nrdy_n_net_x0 <= nrdy_n;
  constant1_x0 <= constant1_op_net_x0;
  constant4_x0 <= constant4_op_net_x0;
  constant5_x0 <= constant5_op_net_x0;
  constant6_x0 <= constant6_op_net_x0;
  inverter1_x0 <= inverter1_op_net_x0;
  inverter2_x0 <= inverter2_op_net_x0;
  inverter_x0 <= inverter_op_net_x0;

  constant1: entity work.constant_184380b232
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant1_op_net_x0
    );

  constant4: entity work.constant_963ed6358a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant4_op_net_x0
    );

  constant5: entity work.constant_963ed6358a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant5_op_net_x0
    );

  constant6: entity work.constant_963ed6358a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant6_op_net_x0
    );

  inverter: entity work.inverter_e5b38cca3b
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      ip(0) => nrdy_n_net_x0,
      op(0) => inverter_op_net_x0
    );

  inverter1: entity work.inverter_e5b38cca3b
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      ip(0) => gpio_sw_c_net_x0,
      op(0) => inverter1_op_net_x0
    );

  inverter2: entity work.inverter_e5b38cca3b
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      ip(0) => gpio_sw_e_net_x0,
      op(0) => inverter2_op_net_x0
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "DDS_PCDAQ"

entity dds_pcdaq is
  port (
    ce_1: in std_logic; 
    clk_1: in std_logic; 
    gpio_dipsw: in std_logic_vector(7 downto 0); 
    gpio_sw_c: in std_logic; 
    gpio_sw_e: in std_logic; 
    nrdy_n: in std_logic; 
    reg_a0: in std_logic_vector(31 downto 0); 
    reg_a4: in std_logic_vector(31 downto 0); 
    reg_a8: in std_logic_vector(31 downto 0); 
    reg_ac: in std_logic_vector(31 downto 0); 
    sys_reset_n_c: in std_logic; 
    dvalid_n: out std_logic; 
    gpio_led: out std_logic_vector(7 downto 0); 
    gpio_led_c: out std_logic; 
    gpio_led_e: out std_logic; 
    gpio_led_n: out std_logic; 
    gpio_led_s: out std_logic; 
    gpio_led_w: out std_logic; 
    if_data: out std_logic_vector(127 downto 0); 
    pattern_match: out std_logic
  );
end dds_pcdaq;

architecture structural of dds_pcdaq is
  attribute core_generation_info: string;
  attribute core_generation_info of structural : architecture is "DDS_PCDAQ,sysgen_core,{clock_period=30.00000000,clocking=Clock_Enables,compilation=HDL_Netlist,sample_periods=1.00000000000,testbench=0,total_blocks=88,xilinx_bit_slice_extractor_block=1,xilinx_bus_concatenator_block=1,xilinx_constant_block_block=8,xilinx_dds_compiler_4_0_block=1,xilinx_gateway_in_block=9,xilinx_gateway_out_block=11,xilinx_inverter_block=3,xilinx_system_generator_block=1,xilinx_type_reinterpreter_block=3,}";

  signal ce_1_sg_x1: std_logic;
  signal clk_1_sg_x1: std_logic;
  signal constant3_op_net: std_logic_vector(15 downto 0);
  signal constant8_op_net: std_logic_vector(15 downto 0);
  signal constant9_op_net: std_logic_vector(15 downto 0);
  signal constant_op_net: std_logic_vector(47 downto 0);
  signal dds_compiler_4_0_cosine_net: std_logic_vector(15 downto 0);
  signal dds_compiler_4_0_sine_net: std_logic_vector(15 downto 0);
  signal dvalid_n_net: std_logic;
  signal gpio_dipsw_net: std_logic_vector(7 downto 0);
  signal gpio_led_c_net: std_logic;
  signal gpio_led_e_net: std_logic;
  signal gpio_led_n_net: std_logic;
  signal gpio_led_net: std_logic_vector(7 downto 0);
  signal gpio_led_s_net: std_logic;
  signal gpio_led_w_net: std_logic;
  signal gpio_sw_c_net: std_logic;
  signal gpio_sw_e_net: std_logic;
  signal if_data_net: std_logic_vector(127 downto 0);
  signal nrdy_n_net_x1: std_logic;
  signal reg_a0_net: std_logic_vector(31 downto 0);
  signal reg_a4_net: std_logic_vector(31 downto 0);
  signal reg_a8_net: std_logic_vector(31 downto 0);
  signal reg_ac_net: std_logic_vector(31 downto 0);
  signal reinterpret1_output_port_net: std_logic_vector(15 downto 0);
  signal reinterpret7_output_port_net: std_logic_vector(31 downto 0);
  signal reinterpret_output_port_net: std_logic_vector(15 downto 0);
  signal slice_bit0_y_net: std_logic;
  signal sys_reset_n_c_net: std_logic;

begin
  ce_1_sg_x1 <= ce_1;
  clk_1_sg_x1 <= clk_1;
  gpio_dipsw_net <= gpio_dipsw;
  gpio_sw_c_net <= gpio_sw_c;
  gpio_sw_e_net <= gpio_sw_e;
  nrdy_n_net_x1 <= nrdy_n;
  reg_a0_net <= reg_a0;
  reg_a4_net <= reg_a4;
  reg_a8_net <= reg_a8;
  reg_ac_net <= reg_ac;
  sys_reset_n_c_net <= sys_reset_n_c;
  dvalid_n <= dvalid_n_net;
  gpio_led <= gpio_led_net;
  gpio_led_c <= gpio_led_c_net;
  gpio_led_e <= gpio_led_e_net;
  gpio_led_n <= gpio_led_n_net;
  gpio_led_s <= gpio_led_s_net;
  gpio_led_w <= gpio_led_w_net;
  if_data <= if_data_net;
  pattern_match <= nrdy_n_net_x1;

  concat: entity work.concat_87e4a5cea3
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      in0 => constant_op_net,
      in1 => constant3_op_net,
      in2 => constant8_op_net,
      in3 => constant9_op_net,
      in4 => reinterpret_output_port_net,
      in5 => reinterpret1_output_port_net,
      y => if_data_net
    );

  constant3: entity work.constant_9f5572ba51
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant3_op_net
    );

  constant8: entity work.constant_9f5572ba51
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant8_op_net
    );

  constant9: entity work.constant_9f5572ba51
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant9_op_net
    );

  constant_x0: entity work.constant_03afa77e34
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant_op_net
    );

  control_logic_fad1345112: entity work.control_logic_entity_fad1345112
    port map (
      ce_1 => ce_1_sg_x1,
      clk_1 => clk_1_sg_x1,
      gpio_sw_c => gpio_sw_c_net,
      gpio_sw_e => gpio_sw_e_net,
      nrdy_n => nrdy_n_net_x1,
      constant1_x0 => gpio_led_net,
      constant4_x0 => gpio_led_n_net,
      constant5_x0 => gpio_led_s_net,
      constant6_x0 => gpio_led_w_net,
      inverter1_x0 => gpio_led_c_net,
      inverter2_x0 => gpio_led_e_net,
      inverter_x0 => dvalid_n_net
    );

  dds_compiler_4_0: entity work.xldds_compiler_b899c74a7f3119eb91144e5c844b45d7
    port map (
      ce => ce_1_sg_x1,
      clk => clk_1_sg_x1,
      data => reinterpret7_output_port_net,
      we => slice_bit0_y_net,
      cosine => dds_compiler_4_0_cosine_net,
      sine => dds_compiler_4_0_sine_net
    );

  reinterpret: entity work.reinterpret_7025463ea8
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => dds_compiler_4_0_sine_net,
      output_port => reinterpret_output_port_net
    );

  reinterpret1: entity work.reinterpret_7025463ea8
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => dds_compiler_4_0_cosine_net,
      output_port => reinterpret1_output_port_net
    );

  reinterpret7: entity work.reinterpret_c5d4d59b73
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => reg_ac_net,
      output_port => reinterpret7_output_port_net
    );

  slice_bit0: entity work.xlslice
    generic map (
      new_lsb => 0,
      new_msb => 0,
      x_width => 32,
      y_width => 1
    )
    port map (
      x => reg_a4_net,
      y(0) => slice_bit0_y_net
    );

end structural;
