library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "PN9"

entity pn9 is
  port (
    ce_1: in std_logic; 
    clk_1: in std_logic; 
    gpio_dipsw: in std_logic_vector(7 downto 0); 
    gpio_sw_c: in std_logic; 
    gpio_sw_e: in std_logic; 
    nrdy_n: in std_logic; 
    reg_a0: in std_logic_vector(31 downto 0); 
    reg_a4: in std_logic_vector(31 downto 0); 
    reg_a8: in std_logic_vector(31 downto 0); 
    reg_ac: in std_logic_vector(31 downto 0); 
    sys_reset_n_c: in std_logic; 
    dvalid_n: out std_logic; 
    gpio_led: out std_logic_vector(7 downto 0); 
    gpio_led_c: out std_logic; 
    gpio_led_e: out std_logic; 
    gpio_led_n: out std_logic; 
    gpio_led_s: out std_logic; 
    gpio_led_w: out std_logic; 
    if_data: out std_logic_vector(127 downto 0); 
    pattern_match: out std_logic
  );
end pn9;

architecture structural of pn9 is
  attribute core_generation_info: string;
  attribute core_generation_info of structural : architecture is "PN9,sysgen_core,{clock_period=30.00000000,clocking=Clock_Enables,compilation=HDL_Netlist,sample_periods=1.00000000000,testbench=0,total_blocks=78,xilinx_assert_block=1,xilinx_bus_concatenator_block=1,xilinx_constant_block_block=9,xilinx_gateway_in_block=9,xilinx_gateway_out_block=9,xilinx_inverter_block=3,xilinx_logical_block_block=1,xilinx_register_block=9,xilinx_system_generator_block=1,xilinx_type_converter_block=1,xilinx_type_reinterpreter_block=1,}";

  signal assert_dout_net: std_logic;
  signal ce_1_sg_x0: std_logic;
  signal clk_1_sg_x0: std_logic;
  signal constant10_op_net: std_logic_vector(15 downto 0);
  signal constant3_op_net: std_logic_vector(15 downto 0);
  signal constant8_op_net: std_logic_vector(15 downto 0);
  signal constant9_op_net: std_logic_vector(15 downto 0);
  signal constant_op_net: std_logic_vector(47 downto 0);
  signal convert1_dout_net: std_logic_vector(15 downto 0);
  signal dvalid_n_net: std_logic;
  signal gpio_dipsw_net: std_logic_vector(7 downto 0);
  signal gpio_led_c_net: std_logic;
  signal gpio_led_e_net: std_logic;
  signal gpio_led_n_net: std_logic;
  signal gpio_led_net: std_logic_vector(7 downto 0);
  signal gpio_led_s_net: std_logic;
  signal gpio_led_w_net: std_logic;
  signal gpio_sw_c_net: std_logic;
  signal gpio_sw_e_net: std_logic;
  signal if_data_net: std_logic_vector(127 downto 0);
  signal logical_y_net: std_logic;
  signal nrdy_n_net_x0: std_logic;
  signal reg_a0_net: std_logic_vector(31 downto 0);
  signal reg_a4_net: std_logic_vector(31 downto 0);
  signal reg_a8_net: std_logic_vector(31 downto 0);
  signal reg_ac_net: std_logic_vector(31 downto 0);
  signal register1_q_net: std_logic;
  signal register2_q_net: std_logic;
  signal register3_q_net: std_logic;
  signal register4_q_net: std_logic;
  signal register5_q_net: std_logic;
  signal register6_q_net: std_logic;
  signal register7_q_net: std_logic;
  signal register8_q_net: std_logic;
  signal register9_q_net: std_logic;
  signal reinterpret6_output_port_net: std_logic_vector(15 downto 0);
  signal sys_reset_n_c_net: std_logic;

begin
  ce_1_sg_x0 <= ce_1;
  clk_1_sg_x0 <= clk_1;
  gpio_dipsw_net <= gpio_dipsw;
  gpio_sw_c_net <= gpio_sw_c;
  gpio_sw_e_net <= gpio_sw_e;
  nrdy_n_net_x0 <= nrdy_n;
  reg_a0_net <= reg_a0;
  reg_a4_net <= reg_a4;
  reg_a8_net <= reg_a8;
  reg_ac_net <= reg_ac;
  sys_reset_n_c_net <= sys_reset_n_c;
  dvalid_n <= dvalid_n_net;
  gpio_led <= gpio_led_net;
  gpio_led_c <= gpio_led_c_net;
  gpio_led_e <= gpio_led_e_net;
  gpio_led_n <= gpio_led_n_net;
  gpio_led_s <= gpio_led_s_net;
  gpio_led_w <= gpio_led_w_net;
  if_data <= if_data_net;
  pattern_match <= nrdy_n_net_x0;

  assert_x0: entity work.xlpassthrough
    generic map (
      din_width => 1,
      dout_width => 1
    )
    port map (
      din(0) => logical_y_net,
      dout(0) => assert_dout_net
    );

  concat: entity work.concat_87e4a5cea3
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      in0 => constant_op_net,
      in1 => constant9_op_net,
      in2 => constant10_op_net,
      in3 => constant8_op_net,
      in4 => constant3_op_net,
      in5 => reinterpret6_output_port_net,
      y => if_data_net
    );

  constant1: entity work.constant_184380b232
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => gpio_led_net
    );

  constant10: entity work.constant_9f5572ba51
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant10_op_net
    );

  constant3: entity work.constant_9f5572ba51
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant3_op_net
    );

  constant4: entity work.constant_963ed6358a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => gpio_led_n_net
    );

  constant5: entity work.constant_963ed6358a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => gpio_led_s_net
    );

  constant6: entity work.constant_963ed6358a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => gpio_led_w_net
    );

  constant8: entity work.constant_9f5572ba51
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant8_op_net
    );

  constant9: entity work.constant_9f5572ba51
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant9_op_net
    );

  constant_x0: entity work.constant_03afa77e34
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant_op_net
    );

  convert1: entity work.xlconvert
    generic map (
      bool_conversion => 0,
      din_arith => 1,
      din_bin_pt => 0,
      din_width => 1,
      dout_arith => 1,
      dout_bin_pt => 0,
      dout_width => 16,
      latency => 0,
      overflow => xlWrap,
      quantization => xlTruncate
    )
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      din(0) => register9_q_net,
      en => "1",
      dout => convert1_dout_net
    );

  inverter: entity work.inverter_e5b38cca3b
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      ip(0) => nrdy_n_net_x0,
      op(0) => dvalid_n_net
    );

  inverter1: entity work.inverter_e5b38cca3b
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      ip(0) => gpio_sw_c_net,
      op(0) => gpio_led_c_net
    );

  inverter2: entity work.inverter_e5b38cca3b
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      ip(0) => gpio_sw_e_net,
      op(0) => gpio_led_e_net
    );

  logical: entity work.logical_e77c53f8bd
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      d0(0) => register9_q_net,
      d1(0) => register5_q_net,
      y(0) => logical_y_net
    );

  register1: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      d(0) => assert_dout_net,
      en => "1",
      rst(0) => dvalid_n_net,
      q(0) => register1_q_net
    );

  register2: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      d(0) => register1_q_net,
      en => "1",
      rst(0) => dvalid_n_net,
      q(0) => register2_q_net
    );

  register3: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      d(0) => register2_q_net,
      en => "1",
      rst(0) => dvalid_n_net,
      q(0) => register3_q_net
    );

  register4: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      d(0) => register3_q_net,
      en => "1",
      rst(0) => dvalid_n_net,
      q(0) => register4_q_net
    );

  register5: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      d(0) => register4_q_net,
      en => "1",
      rst(0) => dvalid_n_net,
      q(0) => register5_q_net
    );

  register6: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      d(0) => register5_q_net,
      en => "1",
      rst(0) => dvalid_n_net,
      q(0) => register6_q_net
    );

  register7: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      d(0) => register6_q_net,
      en => "1",
      rst(0) => dvalid_n_net,
      q(0) => register7_q_net
    );

  register8: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      d(0) => register7_q_net,
      en => "1",
      rst(0) => dvalid_n_net,
      q(0) => register8_q_net
    );

  register9: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      d(0) => register8_q_net,
      en => "1",
      rst(0) => dvalid_n_net,
      q(0) => register9_q_net
    );

  reinterpret6: entity work.reinterpret_ddc3ebdd7c
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => convert1_dout_net,
      output_port => reinterpret6_output_port_net
    );

end structural;
