library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "QPSK_Mod/Control Logic"

entity control_logic_entity_812462b613 is
  port (
    ce_1: in std_logic; 
    clk_1: in std_logic; 
    gpio_sw_c: in std_logic; 
    gpio_sw_e: in std_logic; 
    nrdy_n: in std_logic; 
    constant1_x0: out std_logic_vector(7 downto 0); 
    constant4_x0: out std_logic; 
    constant5_x0: out std_logic; 
    constant6_x0: out std_logic; 
    inverter1_x0: out std_logic; 
    inverter2_x0: out std_logic; 
    inverter_x0: out std_logic
  );
end control_logic_entity_812462b613;

architecture structural of control_logic_entity_812462b613 is
  signal ce_1_sg_x0: std_logic;
  signal clk_1_sg_x0: std_logic;
  signal constant1_op_net_x0: std_logic_vector(7 downto 0);
  signal constant4_op_net_x0: std_logic;
  signal constant5_op_net_x0: std_logic;
  signal constant6_op_net_x0: std_logic;
  signal gpio_sw_c_net_x0: std_logic;
  signal gpio_sw_e_net_x0: std_logic;
  signal inverter1_op_net_x0: std_logic;
  signal inverter2_op_net_x0: std_logic;
  signal inverter_op_net_x0: std_logic;
  signal nrdy_n_net_x0: std_logic;

begin
  ce_1_sg_x0 <= ce_1;
  clk_1_sg_x0 <= clk_1;
  gpio_sw_c_net_x0 <= gpio_sw_c;
  gpio_sw_e_net_x0 <= gpio_sw_e;
  nrdy_n_net_x0 <= nrdy_n;
  constant1_x0 <= constant1_op_net_x0;
  constant4_x0 <= constant4_op_net_x0;
  constant5_x0 <= constant5_op_net_x0;
  constant6_x0 <= constant6_op_net_x0;
  inverter1_x0 <= inverter1_op_net_x0;
  inverter2_x0 <= inverter2_op_net_x0;
  inverter_x0 <= inverter_op_net_x0;

  constant1: entity work.constant_184380b232
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant1_op_net_x0
    );

  constant4: entity work.constant_963ed6358a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant4_op_net_x0
    );

  constant5: entity work.constant_963ed6358a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant5_op_net_x0
    );

  constant6: entity work.constant_963ed6358a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant6_op_net_x0
    );

  inverter: entity work.inverter_e5b38cca3b
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      ip(0) => nrdy_n_net_x0,
      op(0) => inverter_op_net_x0
    );

  inverter1: entity work.inverter_e5b38cca3b
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      ip(0) => gpio_sw_c_net_x0,
      op(0) => inverter1_op_net_x0
    );

  inverter2: entity work.inverter_e5b38cca3b
    port map (
      ce => ce_1_sg_x0,
      clk => clk_1_sg_x0,
      clr => '0',
      ip(0) => gpio_sw_e_net_x0,
      op(0) => inverter2_op_net_x0
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "QPSK_Mod/PN9_TDD_UPx8"

entity pn9_tdd_upx8_entity_4a22fabf10 is
  port (
    ce_1: in std_logic; 
    ce_4: in std_logic; 
    ce_8: in std_logic; 
    clk_1: in std_logic; 
    clk_4: in std_logic; 
    clk_8: in std_logic; 
    out1: out std_logic_vector(15 downto 0); 
    out2: out std_logic_vector(15 downto 0)
  );
end pn9_tdd_upx8_entity_4a22fabf10;

architecture structural of pn9_tdd_upx8_entity_4a22fabf10 is
  signal assert_dout_net: std_logic;
  signal ce_1_sg_x1: std_logic;
  signal ce_4_sg_x0: std_logic;
  signal ce_8_sg_x0: std_logic;
  signal clk_1_sg_x1: std_logic;
  signal clk_4_sg_x0: std_logic;
  signal clk_8_sg_x0: std_logic;
  signal constant3_op_net: std_logic_vector(15 downto 0);
  signal constant5_op_net: std_logic_vector(15 downto 0);
  signal constant6_op_net: std_logic_vector(15 downto 0);
  signal constant8_op_net: std_logic_vector(15 downto 0);
  signal logical_y_net: std_logic;
  signal mux1_y_net: std_logic_vector(15 downto 0);
  signal mux_y_net: std_logic_vector(15 downto 0);
  signal register1_q_net: std_logic;
  signal register2_q_net: std_logic;
  signal register3_q_net: std_logic;
  signal register4_q_net: std_logic;
  signal register5_q_net: std_logic;
  signal register6_q_net: std_logic;
  signal register7_q_net: std_logic;
  signal register8_q_net: std_logic;
  signal register9_q_net: std_logic;
  signal time_division_demultiplexer_q0_net: std_logic;
  signal time_division_demultiplexer_q1_net: std_logic;
  signal up_sample1_q_net_x0: std_logic_vector(15 downto 0);
  signal up_sample2_q_net_x0: std_logic_vector(15 downto 0);

begin
  ce_1_sg_x1 <= ce_1;
  ce_4_sg_x0 <= ce_4;
  ce_8_sg_x0 <= ce_8;
  clk_1_sg_x1 <= clk_1;
  clk_4_sg_x0 <= clk_4;
  clk_8_sg_x0 <= clk_8;
  out1 <= up_sample1_q_net_x0;
  out2 <= up_sample2_q_net_x0;

  assert_x0: entity work.xlpassthrough
    generic map (
      din_width => 1,
      dout_width => 1
    )
    port map (
      din(0) => logical_y_net,
      dout(0) => assert_dout_net
    );

  constant3: entity work.constant_4204ed6f8a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant3_op_net
    );

  constant5: entity work.constant_515f6b5526
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant5_op_net
    );

  constant6: entity work.constant_4204ed6f8a
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant6_op_net
    );

  constant8: entity work.constant_515f6b5526
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant8_op_net
    );

  logical: entity work.logical_e77c53f8bd
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      d0(0) => register5_q_net,
      d1(0) => register9_q_net,
      y(0) => logical_y_net
    );

  mux: entity work.mux_a54904b290
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      d0 => constant3_op_net,
      d1 => constant5_op_net,
      sel(0) => time_division_demultiplexer_q0_net,
      y => mux_y_net
    );

  mux1: entity work.mux_a54904b290
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      d0 => constant6_op_net,
      d1 => constant8_op_net,
      sel(0) => time_division_demultiplexer_q1_net,
      y => mux1_y_net
    );

  register1: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_4_sg_x0,
      clk => clk_4_sg_x0,
      d(0) => assert_dout_net,
      en => "1",
      rst => "0",
      q(0) => register1_q_net
    );

  register2: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_4_sg_x0,
      clk => clk_4_sg_x0,
      d(0) => register1_q_net,
      en => "1",
      rst => "0",
      q(0) => register2_q_net
    );

  register3: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_4_sg_x0,
      clk => clk_4_sg_x0,
      d(0) => register2_q_net,
      en => "1",
      rst => "0",
      q(0) => register3_q_net
    );

  register4: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_4_sg_x0,
      clk => clk_4_sg_x0,
      d(0) => register3_q_net,
      en => "1",
      rst => "0",
      q(0) => register4_q_net
    );

  register5: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_4_sg_x0,
      clk => clk_4_sg_x0,
      d(0) => register4_q_net,
      en => "1",
      rst => "0",
      q(0) => register5_q_net
    );

  register6: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_4_sg_x0,
      clk => clk_4_sg_x0,
      d(0) => register5_q_net,
      en => "1",
      rst => "0",
      q(0) => register6_q_net
    );

  register7: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_4_sg_x0,
      clk => clk_4_sg_x0,
      d(0) => register6_q_net,
      en => "1",
      rst => "0",
      q(0) => register7_q_net
    );

  register8: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_4_sg_x0,
      clk => clk_4_sg_x0,
      d(0) => register7_q_net,
      en => "1",
      rst => "0",
      q(0) => register8_q_net
    );

  register9: entity work.xlregister
    generic map (
      d_width => 1,
      init_value => b"1"
    )
    port map (
      ce => ce_4_sg_x0,
      clk => clk_4_sg_x0,
      d(0) => register8_q_net,
      en => "1",
      rst => "0",
      q(0) => register9_q_net
    );

  time_division_demultiplexer: entity work.xltdd_multich
    generic map (
      data_width => 1,
      frame_length => 2
    )
    port map (
      d(0) => register9_q_net,
      dest_ce => ce_8_sg_x0,
      dest_clk => clk_8_sg_x0,
      dest_clr => '0',
      src_ce => ce_4_sg_x0,
      src_clk => clk_4_sg_x0,
      src_clr => '0',
      q0(0) => time_division_demultiplexer_q0_net,
      q1(0) => time_division_demultiplexer_q1_net
    );

  up_sample1: entity work.xlusamp
    generic map (
      copy_samples => 0,
      d_arith => xlSigned,
      d_bin_pt => 14,
      d_width => 16,
      latency => 0,
      q_arith => xlSigned,
      q_bin_pt => 14,
      q_width => 16
    )
    port map (
      d => mux_y_net,
      dest_ce => ce_1_sg_x1,
      dest_clk => clk_1_sg_x1,
      dest_clr => '0',
      en => "1",
      src_ce => ce_8_sg_x0,
      src_clk => clk_8_sg_x0,
      src_clr => '0',
      q => up_sample1_q_net_x0
    );

  up_sample2: entity work.xlusamp
    generic map (
      copy_samples => 0,
      d_arith => xlSigned,
      d_bin_pt => 14,
      d_width => 16,
      latency => 0,
      q_arith => xlSigned,
      q_bin_pt => 14,
      q_width => 16
    )
    port map (
      d => mux1_y_net,
      dest_ce => ce_1_sg_x1,
      dest_clk => clk_1_sg_x1,
      dest_clr => '0',
      en => "1",
      src_ce => ce_8_sg_x0,
      src_clk => clk_8_sg_x0,
      src_clr => '0',
      q => up_sample2_q_net_x0
    );

end structural;
library IEEE;
use IEEE.std_logic_1164.all;
use work.conv_pkg.all;

-- Generated from Simulink block "QPSK_Mod"

entity qpsk_mod is
  port (
    ce_1: in std_logic; 
    ce_4: in std_logic; 
    ce_8: in std_logic; 
    clk_1: in std_logic; 
    clk_4: in std_logic; 
    clk_8: in std_logic; 
    gpio_dipsw: in std_logic_vector(7 downto 0); 
    gpio_sw_c: in std_logic; 
    gpio_sw_e: in std_logic; 
    nrdy_n: in std_logic; 
    reg_a0: in std_logic_vector(31 downto 0); 
    reg_a4: in std_logic_vector(31 downto 0); 
    reg_a8: in std_logic_vector(31 downto 0); 
    reg_ac: in std_logic_vector(31 downto 0); 
    sys_reset_n_c: in std_logic; 
    dvalid_n: out std_logic; 
    gpio_led: out std_logic_vector(7 downto 0); 
    gpio_led_c: out std_logic; 
    gpio_led_e: out std_logic; 
    gpio_led_n: out std_logic; 
    gpio_led_s: out std_logic; 
    gpio_led_w: out std_logic; 
    if_data: out std_logic_vector(127 downto 0); 
    pattern_match: out std_logic
  );
end qpsk_mod;

architecture structural of qpsk_mod is
  attribute core_generation_info: string;
  attribute core_generation_info of structural : architecture is "QPSK_Mod,sysgen_core,{clock_period=30.00000000,clocking=Clock_Enables,compilation=HDL_Netlist,sample_periods=1.00000000000 4.00000000000 8.00000000000,testbench=0,total_blocks=187,xilinx_adder_subtracter_block=1,xilinx_assert_block=1,xilinx_bit_slice_extractor_block=4,xilinx_bus_concatenator_block=1,xilinx_bus_multiplexer_block=2,xilinx_constant_block_block=11,xilinx_dds_compiler_4_0_block=1,xilinx_fdatool_interface_block=3,xilinx_fir_compiler_6_1_block=2,xilinx_gateway_in_block=9,xilinx_gateway_out_block=12,xilinx_inverter_block=3,xilinx_logical_block_block=1,xilinx_multiplier_block=2,xilinx_register_block=9,xilinx_system_generator_block=1,xilinx_time_division_demultiplexer_block=1,xilinx_type_reinterpreter_block=8,xilinx_up_sampler_block=2,}";

  signal addsub_s_net: std_logic_vector(15 downto 0);
  signal ce_1_sg_x2: std_logic;
  signal ce_4_sg_x1: std_logic;
  signal ce_8_sg_x1: std_logic;
  signal clk_1_sg_x2: std_logic;
  signal clk_4_sg_x1: std_logic;
  signal clk_8_sg_x1: std_logic;
  signal constant12_op_net: std_logic;
  signal constant2_op_net: std_logic;
  signal constant_op_net: std_logic_vector(47 downto 0);
  signal dds_compiler_4_0_cosine_net: std_logic_vector(15 downto 0);
  signal dds_compiler_4_0_sine_net: std_logic_vector(15 downto 0);
  signal dvalid_n_net: std_logic;
  signal fir_compiler_6_1_1_m_axis_data_tdata_net: std_logic_vector(34 downto 0);
  signal fir_compiler_6_1_m_axis_data_tdata_net: std_logic_vector(34 downto 0);
  signal gpio_dipsw_net: std_logic_vector(7 downto 0);
  signal gpio_led_c_net: std_logic;
  signal gpio_led_e_net: std_logic;
  signal gpio_led_n_net: std_logic;
  signal gpio_led_net: std_logic_vector(7 downto 0);
  signal gpio_led_s_net: std_logic;
  signal gpio_led_w_net: std_logic;
  signal gpio_sw_c_net: std_logic;
  signal gpio_sw_e_net: std_logic;
  signal if_data_net: std_logic_vector(127 downto 0);
  signal mult1_p_net: std_logic_vector(15 downto 0);
  signal mult_p_net: std_logic_vector(15 downto 0);
  signal nrdy_n_net_x1: std_logic;
  signal reg_a0_net: std_logic_vector(31 downto 0);
  signal reg_a4_net: std_logic_vector(31 downto 0);
  signal reg_a8_net: std_logic_vector(31 downto 0);
  signal reg_ac_net: std_logic_vector(31 downto 0);
  signal reinterpret1_output_port_net: std_logic_vector(15 downto 0);
  signal reinterpret2_output_port_net: std_logic_vector(15 downto 0);
  signal reinterpret3_output_port_net: std_logic_vector(15 downto 0);
  signal reinterpret4_output_port_net: std_logic_vector(15 downto 0);
  signal reinterpret5_output_port_net: std_logic_vector(15 downto 0);
  signal reinterpret6_output_port_net: std_logic_vector(15 downto 0);
  signal reinterpret7_output_port_net: std_logic_vector(31 downto 0);
  signal reinterpret_output_port_net: std_logic_vector(15 downto 0);
  signal slice1_y_net: std_logic_vector(15 downto 0);
  signal slice_bit0_y_net: std_logic;
  signal slice_bit1_0_y_net: std_logic_vector(1 downto 0);
  signal slice_y_net: std_logic_vector(15 downto 0);
  signal sys_reset_n_c_net: std_logic;
  signal up_sample1_q_net_x0: std_logic_vector(15 downto 0);
  signal up_sample2_q_net_x0: std_logic_vector(15 downto 0);

begin
  ce_1_sg_x2 <= ce_1;
  ce_4_sg_x1 <= ce_4;
  ce_8_sg_x1 <= ce_8;
  clk_1_sg_x2 <= clk_1;
  clk_4_sg_x1 <= clk_4;
  clk_8_sg_x1 <= clk_8;
  gpio_dipsw_net <= gpio_dipsw;
  gpio_sw_c_net <= gpio_sw_c;
  gpio_sw_e_net <= gpio_sw_e;
  nrdy_n_net_x1 <= nrdy_n;
  reg_a0_net <= reg_a0;
  reg_a4_net <= reg_a4;
  reg_a8_net <= reg_a8;
  reg_ac_net <= reg_ac;
  sys_reset_n_c_net <= sys_reset_n_c;
  dvalid_n <= dvalid_n_net;
  gpio_led <= gpio_led_net;
  gpio_led_c <= gpio_led_c_net;
  gpio_led_e <= gpio_led_e_net;
  gpio_led_n <= gpio_led_n_net;
  gpio_led_s <= gpio_led_s_net;
  gpio_led_w <= gpio_led_w_net;
  if_data <= if_data_net;
  pattern_match <= nrdy_n_net_x1;

  addsub: entity work.xladdsub
    generic map (
      a_arith => xlSigned,
      a_bin_pt => 0,
      a_width => 16,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 16,
      c_has_c_out => 0,
      c_latency => 0,
      c_output_width => 17,
      core_name0 => "addsb_11_0_069323d67b6b1bb0",
      extra_registers => 0,
      full_s_arith => 2,
      full_s_width => 17,
      latency => 0,
      overflow => 1,
      quantization => 1,
      s_arith => xlSigned,
      s_bin_pt => 0,
      s_width => 16
    )
    port map (
      a => mult_p_net,
      b => mult1_p_net,
      ce => ce_1_sg_x2,
      clk => clk_1_sg_x2,
      clr => '0',
      en => "1",
      s => addsub_s_net
    );

  concat: entity work.concat_87e4a5cea3
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      in0 => constant_op_net,
      in1 => reinterpret_output_port_net,
      in2 => reinterpret1_output_port_net,
      in3 => reinterpret2_output_port_net,
      in4 => reinterpret4_output_port_net,
      in5 => reinterpret6_output_port_net,
      y => if_data_net
    );

  constant12: entity work.constant_6293007044
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant12_op_net
    );

  constant2: entity work.constant_6293007044
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op(0) => constant2_op_net
    );

  constant_x0: entity work.constant_03afa77e34
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      op => constant_op_net
    );

  control_logic_812462b613: entity work.control_logic_entity_812462b613
    port map (
      ce_1 => ce_1_sg_x2,
      clk_1 => clk_1_sg_x2,
      gpio_sw_c => gpio_sw_c_net,
      gpio_sw_e => gpio_sw_e_net,
      nrdy_n => nrdy_n_net_x1,
      constant1_x0 => gpio_led_net,
      constant4_x0 => gpio_led_n_net,
      constant5_x0 => gpio_led_s_net,
      constant6_x0 => gpio_led_w_net,
      inverter1_x0 => gpio_led_c_net,
      inverter2_x0 => gpio_led_e_net,
      inverter_x0 => dvalid_n_net
    );

  dds_compiler_4_0: entity work.xldds_compiler_e5596acf0a21437e1148fc21f4e34352
    port map (
      ce => ce_1_sg_x2,
      clk => clk_1_sg_x2,
      data => reinterpret7_output_port_net,
      we => slice_bit0_y_net,
      cosine => dds_compiler_4_0_cosine_net,
      sine => dds_compiler_4_0_sine_net
    );

  fir_compiler_6_1: entity work.xlfir_compiler_c3385db69d71095a7cc5260a47a01060
    port map (
      ce => ce_1_sg_x2,
      clk => clk_1_sg_x2,
      s_axis_config_tdata_fsel => slice_bit1_0_y_net,
      s_axis_config_tvalid => constant12_op_net,
      s_axis_data_tdata => up_sample1_q_net_x0,
      s_axis_data_tvalid => constant2_op_net,
      src_ce => ce_1_sg_x2,
      src_clk => clk_1_sg_x2,
      m_axis_data_tdata => fir_compiler_6_1_m_axis_data_tdata_net
    );

  fir_compiler_6_1_1: entity work.xlfir_compiler_c3385db69d71095a7cc5260a47a01060
    port map (
      ce => ce_1_sg_x2,
      clk => clk_1_sg_x2,
      s_axis_config_tdata_fsel => slice_bit1_0_y_net,
      s_axis_config_tvalid => constant12_op_net,
      s_axis_data_tdata => up_sample2_q_net_x0,
      s_axis_data_tvalid => constant2_op_net,
      src_ce => ce_1_sg_x2,
      src_clk => clk_1_sg_x2,
      m_axis_data_tdata => fir_compiler_6_1_1_m_axis_data_tdata_net
    );

  mult: entity work.xlmult
    generic map (
      a_arith => xlSigned,
      a_bin_pt => 15,
      a_width => 16,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 16,
      c_a_type => 0,
      c_a_width => 16,
      c_b_type => 0,
      c_b_width => 16,
      c_baat => 16,
      c_output_width => 32,
      c_type => 0,
      core_name0 => "mult_11_2_13a19c86adbbec0f",
      extra_registers => 0,
      multsign => 2,
      overflow => 1,
      p_arith => xlSigned,
      p_bin_pt => 0,
      p_width => 16,
      quantization => 1
    )
    port map (
      a => dds_compiler_4_0_sine_net,
      b => reinterpret3_output_port_net,
      ce => ce_1_sg_x2,
      clk => clk_1_sg_x2,
      clr => '0',
      core_ce => ce_1_sg_x2,
      core_clk => clk_1_sg_x2,
      core_clr => '1',
      en => "1",
      rst => "0",
      p => mult_p_net
    );

  mult1: entity work.xlmult
    generic map (
      a_arith => xlSigned,
      a_bin_pt => 15,
      a_width => 16,
      b_arith => xlSigned,
      b_bin_pt => 0,
      b_width => 16,
      c_a_type => 0,
      c_a_width => 16,
      c_b_type => 0,
      c_b_width => 16,
      c_baat => 16,
      c_output_width => 32,
      c_type => 0,
      core_name0 => "mult_11_2_13a19c86adbbec0f",
      extra_registers => 0,
      multsign => 2,
      overflow => 1,
      p_arith => xlSigned,
      p_bin_pt => 0,
      p_width => 16,
      quantization => 1
    )
    port map (
      a => dds_compiler_4_0_cosine_net,
      b => reinterpret5_output_port_net,
      ce => ce_1_sg_x2,
      clk => clk_1_sg_x2,
      clr => '0',
      core_ce => ce_1_sg_x2,
      core_clk => clk_1_sg_x2,
      core_clr => '1',
      en => "1",
      rst => "0",
      p => mult1_p_net
    );

  pn9_tdd_upx8_4a22fabf10: entity work.pn9_tdd_upx8_entity_4a22fabf10
    port map (
      ce_1 => ce_1_sg_x2,
      ce_4 => ce_4_sg_x1,
      ce_8 => ce_8_sg_x1,
      clk_1 => clk_1_sg_x2,
      clk_4 => clk_4_sg_x1,
      clk_8 => clk_8_sg_x1,
      out1 => up_sample1_q_net_x0,
      out2 => up_sample2_q_net_x0
    );

  reinterpret: entity work.reinterpret_7025463ea8
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => dds_compiler_4_0_sine_net,
      output_port => reinterpret_output_port_net
    );

  reinterpret1: entity work.reinterpret_7025463ea8
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => dds_compiler_4_0_cosine_net,
      output_port => reinterpret1_output_port_net
    );

  reinterpret2: entity work.reinterpret_7025463ea8
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => reinterpret3_output_port_net,
      output_port => reinterpret2_output_port_net
    );

  reinterpret3: entity work.reinterpret_151459306d
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => slice_y_net,
      output_port => reinterpret3_output_port_net
    );

  reinterpret4: entity work.reinterpret_7025463ea8
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => reinterpret5_output_port_net,
      output_port => reinterpret4_output_port_net
    );

  reinterpret5: entity work.reinterpret_151459306d
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => slice1_y_net,
      output_port => reinterpret5_output_port_net
    );

  reinterpret6: entity work.reinterpret_7025463ea8
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => addsub_s_net,
      output_port => reinterpret6_output_port_net
    );

  reinterpret7: entity work.reinterpret_c5d4d59b73
    port map (
      ce => '0',
      clk => '0',
      clr => '0',
      input_port => reg_ac_net,
      output_port => reinterpret7_output_port_net
    );

  slice: entity work.xlslice
    generic map (
      new_lsb => 17,
      new_msb => 32,
      x_width => 35,
      y_width => 16
    )
    port map (
      x => fir_compiler_6_1_m_axis_data_tdata_net,
      y => slice_y_net
    );

  slice1: entity work.xlslice
    generic map (
      new_lsb => 17,
      new_msb => 32,
      x_width => 35,
      y_width => 16
    )
    port map (
      x => fir_compiler_6_1_1_m_axis_data_tdata_net,
      y => slice1_y_net
    );

  slice_bit0: entity work.xlslice
    generic map (
      new_lsb => 0,
      new_msb => 0,
      x_width => 32,
      y_width => 1
    )
    port map (
      x => reg_a4_net,
      y(0) => slice_bit0_y_net
    );

  slice_bit1_0: entity work.xlslice
    generic map (
      new_lsb => 0,
      new_msb => 1,
      x_width => 32,
      y_width => 2
    )
    port map (
      x => reg_a0_net,
      y => slice_bit1_0_y_net
    );

end structural;
